#include <qpid/messaging/Connection.h>
#include <qpid/messaging/Session.h>
#include <qpid/messaging/Message.h>
#include <qpid/messaging/Receiver.h>
#include <qpid/messaging/Address.h>
#include <iostream>


using namespace qpid::messaging;

int main() {
	Connection conn = Connection("localhost:10001", "");
	Session session;
        Receiver receiver;

	conn.open();
	session = conn.createSession();
        receiver = session.createReceiver("ToApp");

        receiver.setCapacity(10); // ****  Receiver capacity impacts the no of messages read *********

        
        for (int i = 0; i < 50; i++) {
            Message msg;
            if(receiver.fetch(msg, Duration::SECOND)) {
	        std::cout << msg.getContent() << std::endl;
                session.acknowledge();
            }
            else {
	        std::cout << "No messages pending in queue " << std::endl;
            }
          sleep(1);
        }


	receiver.close();
	session.close();
	conn.close();
}
